#

API Docs for: 1.6.0
Show: Inherited Protected Private Deprecated

# DisplayObject Class

Defined in: `src/pixi/display/DisplayObject.js:5`
Module: PIXI

The base class for all objects that are rendered on the screen. This is an abstract class and should not be used on its own rather it should be extended.

## Constructor

### `DisplayObject`

()

Defined in `src/pixi/display/DisplayObject.js:5`

- Index
- Methods
- Properties

## Item Index

### Methods

- _renderCanvas
- _renderWebGL
- click
- getBounds
- getLocalBounds
- mousedown
- mouseout
- mouseover
- mouseup
- mouseupoutside
- setInteractive deprecated
- setStageReference
- tap
- touchend
- touchendoutside
- touchstart

### Properties

- _bounds
- _currentBounds
- _currentBounds
- _interactive
- alpha
- buttonMode
- cacheAsBitmap
- color
- defaultCursor
- dynamic
- filterArea
- filters
- hitArea
- interactive
- mask
- parent
- pivot
- position
- renderable
- rotation
- scale
- stage
- visible
- worldAlpha
- worldTransform
- worldVisible
- x
- y

## Methods

### `_renderCanvas`

(

- `renderSession`

)
private

Defined in `src/pixi/display/DisplayObject.js:584`

Renders the object using the Canvas renderer

#### Parameters:

- `renderSession` RenderSession

### `_renderWebGL`

(

- `renderSession`

)
private

Defined in `src/pixi/display/DisplayObject.js:558`

Renders the object using the WebGL renderer

#### Parameters:

- `renderSession` RenderSession

### `click`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:207`

A callback that is used when the users clicks on the displayObject with their mouse

#### Parameters:

- `interactionData` InteractionData

### `getBounds`

() Rectangle

Defined in `src/pixi/display/DisplayObject.js:461`

Retrieves the bounds of the displayObject as a rectangle object

#### Returns:

Rectangle:

the rectangular bounding area

### `getLocalBounds`

() Rectangle

Defined in `src/pixi/display/DisplayObject.js:473`

Retrieves the local bounds of the displayObject as a rectangle object

#### Returns:

Rectangle:

the rectangular bounding area

### `mousedown`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:213`

A callback that is used when the user clicks the mouse down over the sprite

#### Parameters:

- `interactionData` InteractionData

### `mouseout`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:239`

A callback that is used when the users mouse leaves the displayObject

#### Parameters:

- `interactionData` InteractionData

### `mouseover`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:233`

A callback that is used when the users mouse rolls over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `mouseup`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:219`

A callback that is used when the user releases the mouse that was over the displayObject for this callback to be fired the mouse must have been pressed down over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `mouseupoutside`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:226`

A callback that is used when the user releases the mouse that was over the displayObject but is no longer over the displayObject for this callback to be fired, The touch must have started over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `setInteractive`

(

- `interactive`

)
deprecated

Defined in `src/pixi/display/DisplayObject.js:280`

Deprecated: Simply set the `interactive` property directly

[Deprecated] Indicates if the sprite will have touch and mouse interactivity. It is false by default Instead of using this function you can now simply set the interactive property to true or false

#### Parameters:

- `interactive` Boolean

### `setStageReference`

(

- `stage`

)

Defined in `src/pixi/display/DisplayObject.js:485`

Sets the object's stage reference, the stage this object is connected to

#### Parameters:

- `stage` Stage

  the stage that the object will have as its current stage reference

### `tap`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:250`

A callback that is used when the users taps on the sprite with their finger basically a touch version of click

#### Parameters:

- `interactionData` InteractionData

### `touchend`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:263`

A callback that is used when the user releases a touch over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `touchendoutside`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:269`

A callback that is used when the user releases the touch that was over the displayObject for this callback to be fired, The touch must have started over the sprite

#### Parameters:

- `interactionData` InteractionData

### `touchstart`

(

- `interactionData`

)

Defined in `src/pixi/display/DisplayObject.js:257`

A callback that is used when the user touches over the displayObject

#### Parameters:

- `interactionData` InteractionData

## Properties

### `_bounds`

Rectangle private

Defined in `src/pixi/display/DisplayObject.js:174`

The original, cached bounds of the object

### `_currentBounds`

Rectangle private

Defined in `src/pixi/display/DisplayObject.js:190`

The original, cached mask of the object

### `_currentBounds`

Rectangle private

Defined in `src/pixi/display/DisplayObject.js:182`

The most up-to-date bounds of the object

### `_interactive`

Boolean private

Defined in `src/pixi/display/DisplayObject.js:114`

[read-only] Whether or not the object is interactive, do not toggle directly! use the `interactive` property

### `alpha`

Number

Defined in `src/pixi/display/DisplayObject.js:46`

The opacity of the object.

### `buttonMode`

Boolean

Defined in `src/pixi/display/DisplayObject.js:71`

This is used to indicate if the displayObject should display a mouse hand cursor on rollover

### `cacheAsBitmap`

Boolean

Defined in `src/pixi/display/DisplayObject.js:388`

Set weather or not a the display objects is cached as a bitmap. This basically takes a snap shot of the display object as it is at that moment. It can provide a performance benefit for complex static displayObjects To remove filters simply set this property to 'null'

### `color`

Array<> private

Defined in `src/pixi/display/DisplayObject.js:143`

[NYI] Unknown

### `defaultCursor`

String

Defined in `src/pixi/display/DisplayObject.js:124`

This is the cursor that will be used when the mouse is over this object. To enable this the element must have interaction = true and buttonMode = true

### `dynamic`

Boolean private

Defined in `src/pixi/display/DisplayObject.js:152`

[NYI] Holds whether or not this object is dynamic, for rendering optimization

### `filterArea`

Rectangle

Defined in `src/pixi/display/DisplayObject.js:165`

The area the filter is applied to like the hitArea this is used as more of an optimisation rather than figuring out the dimensions of the displayObject each frame you can set this rectangle

### `filters`

Array An array of filters

Defined in `src/pixi/display/DisplayObject.js:354`

Sets the filters for the displayObject.

- IMPORTANT: This is a webGL only feature and will be ignored by the canvas renderer. To remove filters simply set this property to 'null'

### `hitArea`

Rectangle | Circle | Ellipse | Polygon

Defined in `src/pixi/display/DisplayObject.js:62`

This is the defined area that will pick up mouse / touch events. It is null by default. Setting it is a neat way of optimising the hitTest function that the interactionManager will use (as it will not need to hit test all the children)

### `interactive`

Boolean

Defined in `src/pixi/display/DisplayObject.js:293`

Indicates if the sprite will have touch and mouse interactivity. It is false by default

Default: false

### `mask`

Graphics

Defined in `src/pixi/display/DisplayObject.js:334`

Sets a mask for the displayObject. A mask is an object that limits the visibility of an object to the shape of the mask applied to it. In PIXI a regular mask must be a PIXI.Graphics object. This allows for much faster masking in canvas as it utilises shape clipping. To remove a mask, set this property to null.

### `parent`

DisplayObjectContainer

Defined in `src/pixi/display/DisplayObject.js:87`

[read-only] The display object container that contains this display object.

### `pivot`

Point

Defined in `src/pixi/display/DisplayObject.js:30`

The pivot point of the displayObject that it rotates around

### `position`

Point

Defined in `src/pixi/display/DisplayObject.js:14`

The coordinate of the object relative to the local coordinates of the parent.

### `renderable`

Boolean

Defined in `src/pixi/display/DisplayObject.js:79`

Can this object be rendered

### `rotation`

Number

Defined in `src/pixi/display/DisplayObject.js:38`

The rotation of the object in radians.

### `scale`

Point

Defined in `src/pixi/display/DisplayObject.js:22`

The scale factor of the object.

### `stage`

Stage

Defined in `src/pixi/display/DisplayObject.js:96`

[read-only] The stage the display object is connected to, or undefined if it is not connected to the stage.

### `visible`

Boolean

Defined in `src/pixi/display/DisplayObject.js:54`

The visibility of the object.

### `worldAlpha`

Number

Defined in `src/pixi/display/DisplayObject.js:105`

[read-only] The multiplied alpha of the displayObject

### `worldTransform`

Mat3 private

Defined in `src/pixi/display/DisplayObject.js:133`

[read-only] Current transform of the object based on world (parent) factors

### `worldVisible`

Boolean

Defined in `src/pixi/display/DisplayObject.js:313`

[read-only] Indicates if the sprite is globaly visible.

### `x`

Number

Defined in `src/pixi/display/DisplayObject.js:598`

The position of the displayObject on the x axis relative to the local coordinates of the parent.

### `y`

Number

Defined in `src/pixi/display/DisplayObject.js:613`

The position of the displayObject on the y axis relative to the local coordinates of the parent.